#include "wiimote.h"
#include "mywiimote_nun.h"
#include <math.h>

struct wiimote *cWiiRemote;

int wiiinit()
{
	int t=0;
	cWiiRemote = new wiimote();
	// ڑJn
	for(t=0; t<4; t++){
		if(cWiiRemote->Connect(wiimote::FIRST_AVAILABLE)) break;
		Sleep(1000);
	}
	// {^, x, ԊOZT, ̑擾p
	if(cWiiRemote->NunchukConnected()){
		cWiiRemote->SetReportType(wiimote::IN_BUTTONS_ACCEL_IR_EXT);
	}else{
		cWiiRemote->SetReportType(wiimote::IN_BUTTONS_ACCEL_IR);
	}
	if(t==4) return 0;
	return 1;
}
int wiidel()
{
	// ڑI
	if(cWiiRemote){
		cWiiRemote->Disconnect();
		delete cWiiRemote;
	}
	return 1;
}


void wiirumble(bool sw)
{
	cWiiRemote->SetRumble(sw);
}
void wiibutton(WIISTATE &Wiistate)
{
	if(cWiiRemote->Button.One()) Wiistate.Button[WiiKeyNum::KEY1]++;
	else Wiistate.Button[WiiKeyNum::KEY1] = -(Wiistate.Button[WiiKeyNum::KEY1]>0);
	if(cWiiRemote->Button.Two()) Wiistate.Button[WiiKeyNum::KEY2]++;
	else Wiistate.Button[WiiKeyNum::KEY2] = -(Wiistate.Button[WiiKeyNum::KEY2]>0);

	if(cWiiRemote->Button.A()) Wiistate.Button[WiiKeyNum::A]++;
	else Wiistate.Button[WiiKeyNum::A] = -(Wiistate.Button[WiiKeyNum::A]>0);
	if(cWiiRemote->Button.B()) Wiistate.Button[WiiKeyNum::B]++;
	else Wiistate.Button[WiiKeyNum::B] = -(Wiistate.Button[WiiKeyNum::B]>0);

	if(cWiiRemote->Button.Minus()) Wiistate.Button[WiiKeyNum::MINUS]++;
	else Wiistate.Button[WiiKeyNum::MINUS] = -(Wiistate.Button[WiiKeyNum::MINUS]>0);
	if(cWiiRemote->Button.Plus()) Wiistate.Button[WiiKeyNum::PLUS]++;
	else Wiistate.Button[WiiKeyNum::PLUS] = -(Wiistate.Button[WiiKeyNum::PLUS]>0);
	if(cWiiRemote->Button.Home()) Wiistate.Button[WiiKeyNum::HOME]++;
	else Wiistate.Button[WiiKeyNum::HOME] = -(Wiistate.Button[WiiKeyNum::HOME]>0);

	if(cWiiRemote->Button.Up()) Wiistate.Button[WiiKeyNum::UP]++;
	else Wiistate.Button[WiiKeyNum::UP] = -(Wiistate.Button[WiiKeyNum::UP]>0);
	if(cWiiRemote->Button.Down()) Wiistate.Button[WiiKeyNum::DOWN]++;
	else Wiistate.Button[WiiKeyNum::DOWN] = -(Wiistate.Button[WiiKeyNum::DOWN]>0);
	if(cWiiRemote->Button.Right()) Wiistate.Button[WiiKeyNum::RIGHT]++;
	else Wiistate.Button[WiiKeyNum::RIGHT] = -(Wiistate.Button[WiiKeyNum::RIGHT]>0);
	if(cWiiRemote->Button.Left()) Wiistate.Button[WiiKeyNum::LEFT]++;
	else Wiistate.Button[WiiKeyNum::LEFT] = -(Wiistate.Button[WiiKeyNum::LEFT]>0);
}
void wiinunbutton(WIISTATE &Wiistate)
{
	if(cWiiRemote->Nunchuk.C) Wiistate.NunchukButton[WiiNunchukKeyNum::C]++;
	else Wiistate.NunchukButton[WiiNunchukKeyNum::C] =
		-(Wiistate.NunchukButton[WiiNunchukKeyNum::C]>0);
	if(cWiiRemote->Nunchuk.Z) Wiistate.NunchukButton[WiiNunchukKeyNum::Z]++;
	else Wiistate.NunchukButton[WiiNunchukKeyNum::Z] =
		-(Wiistate.NunchukButton[WiiNunchukKeyNum::Z]>0);
}
void getwiistate(WIISTATE &Wiistate)
{
	if(cWiiRemote->RefreshState() != NO_CHANGE) wiibutton(Wiistate);	// {^̏Ԏ擾
	Wiistate.BatteryPercent = (char)cWiiRemote->BatteryPercent;				// obecʎ擾
	// xZT̃f[^擾
	Wiistate.Acceleration.X = cWiiRemote->Acceleration.X;							// xW
	Wiistate.Acceleration.Y = cWiiRemote->Acceleration.Y;							// yW
	Wiistate.Acceleration.Z = cWiiRemote->Acceleration.Z;							// zW
	Wiistate.Acceleration.ABS = sqrt(Wiistate.Acceleration.X*Wiistate.Acceleration.X
																 + Wiistate.Acceleration.Y*Wiistate.Acceleration.Y
																 + Wiistate.Acceleration.Z*Wiistate.Acceleration.Z);
	// ԊOZT̃f[^擾
	for(int t=0; t<4; t++){
		if(Wiistate.Ir[t].bVisible = cWiiRemote->IR.Dot[t].bVisible){
			// LEDZTŕ߂炦Ă
			Wiistate.Ir[t].Size = cWiiRemote->IR.Dot[t].Size;							// LED̋
			Wiistate.Ir[t].X = cWiiRemote->IR.Dot[t].X;										// xW
			Wiistate.Ir[t].Y = cWiiRemote->IR.Dot[t].Y;										// yW

			Wiistate.Ir[t].RawX = cWiiRemote->IR.Dot[t].RawX;							// f[^X
			Wiistate.Ir[t].RawY = cWiiRemote->IR.Dot[t].RawY;							// f[^Y
		}
	}
	wiirumble(Wiistate.RumbleSwitch);																	// Uݒ
	cWiiRemote->SetLEDs((BYTE)Wiistate.LEDSwitch);										// LEDݒ

	// k`N
	Wiistate.NunchukCon = cWiiRemote->NunchukConnected();
	if(Wiistate.NunchukCon){
		// {^̏Ԏ擾
		wiinunbutton(Wiistate);
		// k`N̉xZT̃f[^擾
		Wiistate.NunchukAccel.X = cWiiRemote->Nunchuk.Acceleration.X;		// xW
		Wiistate.NunchukAccel.Y = cWiiRemote->Nunchuk.Acceleration.Y;		// yW
		Wiistate.NunchukAccel.Z = cWiiRemote->Nunchuk.Acceleration.Z;		// zW
		Wiistate.NunchukAccel.ABS = sqrt(Wiistate.NunchukAccel.X*Wiistate.NunchukAccel.X
																	 + Wiistate.NunchukAccel.Y*Wiistate.NunchukAccel.Y
																	 + Wiistate.NunchukAccel.Z*Wiistate.NunchukAccel.Z);
		// k`ÑWCXeBbN̏Ԏ擾
		Wiistate.NunchukJoy.X = cWiiRemote->Nunchuk.Joystick.X;
		Wiistate.NunchukJoy.Y = cWiiRemote->Nunchuk.Joystick.Y;
	}
}